<?php
namespace Teknisa\CTB\Controllers;

use Zeedhi\Framework\DB\StoredProcedure\StoredProcedure;
use Zeedhi\Framework\DB\StoredProcedure\Param;
use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DTO\Response;
use Teknisa\CTB\Services\Ctb6900RelatorioAcompanhamentoOrCSerice;

class Ctb6900RelatorioAcompanhamentoOrController extends \Zeedhi\Framework\Controller\Report {
    
    protected $novoCodigo;
    protected $procedureNutriente;
    protected $parameterBagColumns;
    protected $entityManager;
    protected $qr2Strategy;
    protected $nrsequnutr;
    protected $cdfilial;
    protected $nrorg;
    protected $connection;


    public function __construct($reportService, $novoCodigo, $entityManager, $qr2Strategy, $connection, Ctb6900RelatorioAcompanhamentoOrCSerice $ctb6900relatorioacompanhamentoorcservie) {
        $this->reportService      = $reportService;
        $this->novoCodigo         = $novoCodigo;
        $this->entityManager      = $entityManager;
        $this->qr2Strategy        = $qr2Strategy;
        $this->connection         = $connection;
        $this->Ctb6900RelatorioAcompanhamentoOrCSerice = $ctb6900relatorioacompanhamentoorcservie;
    }

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response){
        $row = $request->getRow();
        set_time_limit(14400);
        ini_set("defaut_socket_timeout", 0);
     /*   $row['DTFIMPERIODO'] ='31/12/2021' ;

        $row['DTINIPERIODO'] ='01/01/2021' ;
        $row['CDEMPRESA'] ='_01_02_03_06_07_09_16_18_22_23_25_65_67_70_' ;*/


        try {
            ini_set('default_socket_timeout', 14400);
        } catch (\Exception $e) {}
        $this->qr2Strategy->setQr2Type($row['QR2TYPE']);
    }
    
    public function geraRelatoriosAcompOrcamContabilidade(DTO\Request\Row $request, DTO\Response $response) {
    try{
        
        $row = $request->getRow();
        $reportName = $row["REPORT_CODE"];
        if($row["REPORT_CODE"] == 'CTB69000'){ // Acompanhamento Orçamentário Analítico por Item de Estrutura
            // $relOrcamento = $this->Ctb6900RelatorioAcompanhamentoOrCSerice->execProcGERA_REL_ACOMPANHAMENTO_ORCA($row);
            // $reportMapping = array(
            //     'NRORG' =>  $row["NRORG"],
            //     'CDEMPRESA' => $row["CDEMPRESA"],
            //     'DATAINIC' => $row["DTINIPERIODO"],
            //     'DATAFIN' => $row["DTFIMPERIODO"],
            //     'NRBALANCETE' => $balancete,
            //     "__format" => $row["TIPOREPORT"]
            // );
            //  $type = 'BIRT';
             
            // $birtQr2Url = $this->reportService->createRemoteReport($type, $reportName, $reportMapping);
            // $response->addMessage(new DTO\Response\Message($birtQr2Url));
            throw new \Exception("Atenção, nenhum dado a ser listado!");
        }
       
        
    } catch (\Exception $e){
      $response->setError(new Response\Error($e->getMessage(), $e->getCode()));
    }
  }
}