<?php
namespace Teknisa\CTB\Factories;

use Doctrine\ORM\EntityManager;

class Ger17700RendimentosSociosFactory{

    protected $connection;

    public function __construct(EntityManager $entityManager) {
        $this->connection = $entityManager->getConnection();
    }
    
    public function deleteSocioChildren($params) {
        $sql1 = "DELETE FROM SOCIOEMPRESA WHERE NRSEQREG = :NRSEQREG AND NRORG = :NRORG";
        $sql2 = "DELETE FROM REGY611ECF WHERE NRSEQREG = :NRSEQREG AND NRORG = :NRORG";
        
        $std = $this->connection->prepare($sql1);
        $std->execute($params);
        
        $std = $this->connection->prepare($sql2);
        $std->execute($params);
    }

    public function verificaRelacaoSocioEmpresa($params) {
        $sql = "SELECT 1 FROM SOCIOEMPRESA WHERE CDEMPRESA = :CDEMPRESA AND NRSEQREG = :NRSEQREG AND NRORG = :NRORG ";
        $std = $this->connection->prepare($sql);
        $std->execute($params);
        return $std->fetch();
    }
    
    public function verificaRendimentoAnoEmpresa($params) {
        $sql = "SELECT 1 FROM REGY611ECF WHERE CDEMPRESA = :CDEMPRESA AND DTREFERENCIA = :DTREFERENCIA AND NRSEQREG = :NRSEQREG AND NRORG = :NRORG";
        $std = $this->connection->prepare($sql);
        $std-> execute($params);
        return $std->fetch();
    }
    
}
